﻿using Microsoft.Practices.Prism.Regions;
using System;
using System.Windows;

namespace IgOutlook.Infrastructure.Dialogs
{
    public class DialogService : IDialogService
    {
        IRegionManager _regionManager;
        FrameworkElement _dialogInstance;

        public DialogService(IRegionManager regionManager)
        {
            _regionManager = regionManager;
        }

        public void ShowRibbonDialog(string navigationUri)
        {
            RibbonDialog dialog = new RibbonDialog();
            _dialogInstance = dialog;
            var newRegionManager = _regionManager.CreateRegionManager();
            Microsoft.Practices.Prism.Regions.RegionManager.SetRegionManager(dialog, newRegionManager);
            newRegionManager.RequestNavigate(RegionNames.ContentRegion, navigationUri);

            dialog.Owner = System.Windows.Application.Current.MainWindow;
            dialog.ShowInTaskbar = true;
            dialog.ShowActivated = true;            
            dialog.Show();
        }

        public FrameworkElement GetDialogInstance()
        {
            return _dialogInstance;
        }
    }
}
